package sk.seges.acris.site.server.service.spring;

import javax.annotation.Generated;
import javax.persistence.EntityManager;

import org.springframework.transaction.annotation.Transactional;

import sk.seges.acris.server.model.dto.configuration.FTPWebSettingsDTOConverter;
import sk.seges.acris.server.model.dto.configuration.WebSettingsDTOConverter;
import sk.seges.acris.shared.model.dto.FTPWebSettingsDTO;
import sk.seges.acris.shared.model.dto.WebSettingsDTO;
import sk.seges.acris.site.server.domain.api.server.model.data.WebSettingsData;
import sk.seges.acris.site.server.domain.ftp.server.model.data.FTPWebSettingsData;
import sk.seges.acris.site.server.service.IWebSettingsServiceLocal;
import sk.seges.acris.site.shared.service.IWebSettingsService;
import sk.seges.corpis.service.annotation.TransactionPropagation.PropagationTarget;
import sk.seges.corpis.service.annotation.TransactionPropagation.PropagationType;
import sk.seges.corpis.service.annotation.TransactionPropagationModel;
import sk.seges.sesam.pap.service.annotation.LocalServiceConverter;
import sk.seges.sesam.shared.model.converter.AbstractConverterProvider;
import sk.seges.sesam.shared.model.converter.ConvertedInstanceCache;
import sk.seges.sesam.shared.model.converter.MapConvertedInstanceCache;
import sk.seges.sesam.shared.model.converter.api.ConverterProvider;
import sk.seges.sesam.shared.model.converter.api.DtoConverter;
import sk.seges.sesam.shared.model.converter.api.InstantiableDtoConverter;

@LocalServiceConverter(remoteServices = {IWebSettingsService.class})
@Generated(value = "sk.seges.corpis.appscaffold.model.pap.DataServiceConverterProcessor")
public class SpringWebSettingsServiceConverter implements IWebSettingsService {

	protected IWebSettingsServiceLocal iWebSettingsServiceLocalService;
	protected EntityManager entityManager;


	public SpringWebSettingsServiceConverter(IWebSettingsServiceLocal iWebSettingsServiceLocalService, EntityManager entityManager) {

		this.iWebSettingsServiceLocalService = iWebSettingsServiceLocalService;
		this.entityManager = entityManager;
	}

	@Transactional
	public WebSettingsDTO getWebSettings(String arg0){
		TransactionPropagationModel[] transactionPropagations = new TransactionPropagationModel[] {new TransactionPropagationModel(new String[] {}, new PropagationTarget[] {PropagationTarget.RETURN_VALUE, PropagationTarget.ARGUMENTS}, PropagationType.PROPAGATE)};
		SpringWebSettingsServiceConverterProvider converterProvider = getConverterProvider(transactionPropagations);
		WebSettingsData result = iWebSettingsServiceLocalService.getWebSettings(arg0);
		return (WebSettingsDTO)ensureDomainWebSettingsDTOConverter(transactionPropagations, new MapConvertedInstanceCache(), converterProvider, result).toDto(result);
	}

	@Transactional
	public void saveWebSettings(WebSettingsDTO arg0){
		TransactionPropagationModel[] transactionPropagations = new TransactionPropagationModel[] {new TransactionPropagationModel(new String[] {}, new PropagationTarget[] {PropagationTarget.RETURN_VALUE, PropagationTarget.ARGUMENTS}, PropagationType.PROPAGATE)};
		SpringWebSettingsServiceConverterProvider converterProvider = getConverterProvider(transactionPropagations);
		iWebSettingsServiceLocalService.saveWebSettings((WebSettingsData)ensureDtoWebSettingsDTOConverter(transactionPropagations, new MapConvertedInstanceCache(), converterProvider, (WebSettingsDTO)arg0).fromDto(arg0));
	}

	@Transactional
	public void saveFTPWebSettings(String arg0, FTPWebSettingsDTO arg1){
		TransactionPropagationModel[] transactionPropagations = new TransactionPropagationModel[] {new TransactionPropagationModel(new String[] {}, new PropagationTarget[] {PropagationTarget.RETURN_VALUE, PropagationTarget.ARGUMENTS}, PropagationType.PROPAGATE)};
		SpringWebSettingsServiceConverterProvider converterProvider = getConverterProvider(transactionPropagations);
		iWebSettingsServiceLocalService.saveFTPWebSettings(arg0, (FTPWebSettingsData)ensureDtoFTPWebSettingsDTOConverter(transactionPropagations, new MapConvertedInstanceCache(), converterProvider, (FTPWebSettingsDTO)arg1).fromDto(arg1));
	}

	public FTPWebSettingsDTO getFTPWebSettings(String arg0){
		TransactionPropagationModel[] transactionPropagations = new TransactionPropagationModel[] {new TransactionPropagationModel(new String[] {}, new PropagationTarget[] {PropagationTarget.RETURN_VALUE, PropagationTarget.ARGUMENTS}, PropagationType.ISOLATE)};
		SpringWebSettingsServiceConverterProvider converterProvider = getConverterProvider(transactionPropagations);
		FTPWebSettingsData result = iWebSettingsServiceLocalService.getFTPWebSettings(arg0);
		return (FTPWebSettingsDTO)ensureDomainFTPWebSettingsDTOConverter(transactionPropagations, new MapConvertedInstanceCache(), converterProvider, result).toDto(result);
	}

	protected SpringWebSettingsServiceConverterProvider getConverterProvider(TransactionPropagationModel[] transactionPropagations) {
		return new SpringWebSettingsServiceConverterProvider(transactionPropagations);
	}

	public class SpringWebSettingsServiceConverterProvider extends AbstractConverterProvider {

		protected final TransactionPropagationModel[] transactionPropagations;

		protected SpringWebSettingsServiceConverterProvider(TransactionPropagationModel[] transactionPropagations) {
			this.transactionPropagations = transactionPropagations;
		}

		public <DTO, DOMAIN> DtoConverter<DTO, DOMAIN> getConverterForDomain(Class<DOMAIN> domainClass, ConvertedInstanceCache cache) {

			if (domainClass == null) {
				return null;
			}

			if (WebSettingsData.class.isAssignableFrom(domainClass)) {
				return (DtoConverter<DTO, DOMAIN>) getDomainWebSettingsDTOConverter(transactionPropagations, cache, this, (Class<WebSettingsData>)domainClass);
			}

			if (FTPWebSettingsData.class.isAssignableFrom(domainClass)) {
				return (DtoConverter<DTO, DOMAIN>) getDomainFTPWebSettingsDTOConverter(transactionPropagations, cache, this, (Class<FTPWebSettingsData>)domainClass);
			}

			return null;
		}

		public <DTO, DOMAIN> DtoConverter<DTO, DOMAIN> getConverterForDto(Class<DTO> dto, ConvertedInstanceCache cache) {

			if (dto == null) {
				return null;
			}

			if (WebSettingsDTO.class.isAssignableFrom(dto)) {
				return (DtoConverter<DTO, DOMAIN>) getDtoWebSettingsDTOConverter(transactionPropagations, cache, this, (Class<WebSettingsDTO>)dto);
			}

			if (FTPWebSettingsDTO.class.isAssignableFrom(dto)) {
				return (DtoConverter<DTO, DOMAIN>) getDtoFTPWebSettingsDTOConverter(transactionPropagations, cache, this, (Class<FTPWebSettingsDTO>)dto);
			}

			return null;
		}

	}
	protected <DTO extends WebSettingsDTO, DOMAIN extends WebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> ensureDomainWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, WebSettingsData obj) {
		if (obj == null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDomainWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends WebSettingsData>)null);
		}

		return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDomainWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends WebSettingsData>)obj.getClass());
	}
	
	protected <DTO extends WebSettingsDTO, DOMAIN extends WebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> ensureDomainWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends WebSettingsData> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDomain(objClass, cache);
		if (converter != null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) converter;
		}
		return getDomainWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, objClass);
	}

	protected <DTO extends WebSettingsDTO, DOMAIN extends WebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> ensureDtoWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, WebSettingsDTO obj) {
		if (obj == null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDtoWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends WebSettingsDTO>)null);
		}

		return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDtoWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends WebSettingsDTO>)obj.getClass());
	}
	
	protected <DTO extends WebSettingsDTO, DOMAIN extends WebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> ensureDtoWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends WebSettingsDTO> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDto(objClass, cache);
		if (converter != null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) converter;
		}
		return getDtoWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, objClass);
	}

	protected <DTO extends WebSettingsDTO, DOMAIN extends WebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> getDomainWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends WebSettingsData> objClass){
		return (InstantiableDtoConverter<DTO, DOMAIN>)new WebSettingsDTOConverter(entityManager, transactionPropagations, cache, converterProvider);
	}

	protected <DTO extends WebSettingsDTO, DOMAIN extends WebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> getDtoWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends WebSettingsDTO> objClass){
		return (InstantiableDtoConverter<DTO, DOMAIN>)new WebSettingsDTOConverter(entityManager, transactionPropagations, cache, converterProvider);
	}

	protected <DTO extends FTPWebSettingsDTO, DOMAIN extends FTPWebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> ensureDomainFTPWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, FTPWebSettingsData obj) {
		if (obj == null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDomainFTPWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends FTPWebSettingsData>)null);
		}

		return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDomainFTPWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends FTPWebSettingsData>)obj.getClass());
	}
	
	protected <DTO extends FTPWebSettingsDTO, DOMAIN extends FTPWebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> ensureDomainFTPWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends FTPWebSettingsData> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDomain(objClass, cache);
		if (converter != null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) converter;
		}
		return getDomainFTPWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, objClass);
	}

	protected <DTO extends FTPWebSettingsDTO, DOMAIN extends FTPWebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> ensureDtoFTPWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, FTPWebSettingsDTO obj) {
		if (obj == null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDtoFTPWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends FTPWebSettingsDTO>)null);
		}

		return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDtoFTPWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends FTPWebSettingsDTO>)obj.getClass());
	}
	
	protected <DTO extends FTPWebSettingsDTO, DOMAIN extends FTPWebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> ensureDtoFTPWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends FTPWebSettingsDTO> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDto(objClass, cache);
		if (converter != null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) converter;
		}
		return getDtoFTPWebSettingsDTOConverter(transactionPropagations, cache, converterProvider, objClass);
	}

	protected <DTO extends FTPWebSettingsDTO, DOMAIN extends FTPWebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> getDomainFTPWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends FTPWebSettingsData> objClass){
		return (InstantiableDtoConverter<DTO, DOMAIN>)new FTPWebSettingsDTOConverter(entityManager, transactionPropagations, cache, converterProvider);
	}

	protected <DTO extends FTPWebSettingsDTO, DOMAIN extends FTPWebSettingsData> InstantiableDtoConverter<DTO, DOMAIN> getDtoFTPWebSettingsDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends FTPWebSettingsDTO> objClass){
		return (InstantiableDtoConverter<DTO, DOMAIN>)new FTPWebSettingsDTOConverter(entityManager, transactionPropagations, cache, converterProvider);
	}

}