package sk.seges.acris.site.server.service.spring;

import java.util.Collection;
import java.util.List;

import javax.annotation.Generated;
import javax.persistence.EntityManager;

import org.springframework.transaction.annotation.Transactional;

import sk.seges.acris.server.model.dto.configuration.WebSitesDTOConverter;
import sk.seges.acris.shared.model.dto.WebSitesDTO;
import sk.seges.acris.site.server.domain.api.server.model.data.WebSitesData;
import sk.seges.acris.site.server.service.IWebSitesServiceLocal;
import sk.seges.acris.site.shared.service.IWebSitesService;
import sk.seges.corpis.service.annotation.TransactionPropagation.PropagationTarget;
import sk.seges.corpis.service.annotation.TransactionPropagation.PropagationType;
import sk.seges.corpis.service.annotation.TransactionPropagationModel;
import sk.seges.sesam.pap.service.annotation.LocalServiceConverter;
import sk.seges.sesam.shared.model.converter.AbstractConverterProvider;
import sk.seges.sesam.shared.model.converter.ConvertedInstanceCache;
import sk.seges.sesam.shared.model.converter.MapConvertedInstanceCache;
import sk.seges.sesam.shared.model.converter.api.ConverterProvider;
import sk.seges.sesam.shared.model.converter.api.DtoConverter;
import sk.seges.sesam.shared.model.converter.api.InstantiableDtoConverter;
import sk.seges.sesam.shared.model.converter.common.CollectionConverter;

@LocalServiceConverter(remoteServices = {IWebSitesService.class})
@Generated(value = "sk.seges.corpis.appscaffold.model.pap.DataServiceConverterProcessor")
public class SpringWebSitesServiceConverter implements IWebSitesService {

	protected IWebSitesServiceLocal iWebSitesServiceLocalService;
	protected EntityManager entityManager;


	public SpringWebSitesServiceConverter(IWebSitesServiceLocal iWebSitesServiceLocalService, EntityManager entityManager) {

		this.iWebSitesServiceLocalService = iWebSitesServiceLocalService;
		this.entityManager = entityManager;
	}

	@Override
	@Transactional
	public List<WebSitesDTO> getWebSites(String arg0){
		TransactionPropagationModel[] transactionPropagations = new TransactionPropagationModel[] {new TransactionPropagationModel(new String[] {}, new PropagationTarget[] {PropagationTarget.RETURN_VALUE, PropagationTarget.ARGUMENTS}, PropagationType.PROPAGATE)};
		SpringWebSitesServiceConverterProvider converterProvider = getConverterProvider(transactionPropagations);
		List<WebSitesData> result = iWebSitesServiceLocalService.getWebSites(arg0);
		return (List<WebSitesDTO>)((CollectionConverter)ensureDomainCollectionConverter(new MapConvertedInstanceCache(), converterProvider, result)).toDto(result);
	}

	@Override
	@Transactional
	public void addWebSite(WebSitesDTO arg0){
		TransactionPropagationModel[] transactionPropagations = new TransactionPropagationModel[] {new TransactionPropagationModel(new String[] {}, new PropagationTarget[] {PropagationTarget.RETURN_VALUE, PropagationTarget.ARGUMENTS}, PropagationType.PROPAGATE)};
		SpringWebSitesServiceConverterProvider converterProvider = getConverterProvider(transactionPropagations);
		iWebSitesServiceLocalService.addWebSite((WebSitesData)ensureDtoWebSitesDTOConverter(transactionPropagations, new MapConvertedInstanceCache(), converterProvider, (WebSitesDTO)arg0).fromDto(arg0));
	}

	@Override
	@Transactional
	public WebSitesDTO getPrimaryWebSite(String arg0, String arg1){
		TransactionPropagationModel[] transactionPropagations = new TransactionPropagationModel[] {new TransactionPropagationModel(new String[] {}, new PropagationTarget[] {PropagationTarget.RETURN_VALUE, PropagationTarget.ARGUMENTS}, PropagationType.PROPAGATE)};
		SpringWebSitesServiceConverterProvider converterProvider = getConverterProvider(transactionPropagations);
		WebSitesData result = iWebSitesServiceLocalService.getPrimaryWebSite(arg0, arg1);
		return (WebSitesDTO)ensureDomainWebSitesDTOConverter(transactionPropagations, new MapConvertedInstanceCache(), converterProvider, result).toDto(result);
	}

	protected SpringWebSitesServiceConverterProvider getConverterProvider(TransactionPropagationModel[] transactionPropagations) {
		return new SpringWebSitesServiceConverterProvider(transactionPropagations);
	}

	public class SpringWebSitesServiceConverterProvider extends AbstractConverterProvider {

		protected final TransactionPropagationModel[] transactionPropagations;

		protected SpringWebSitesServiceConverterProvider(TransactionPropagationModel[] transactionPropagations) {
			this.transactionPropagations = transactionPropagations;
		}

		public <DTO, DOMAIN> DtoConverter<DTO, DOMAIN> getConverterForDomain(Class<DOMAIN> domainClass, ConvertedInstanceCache cache) {

			if (domainClass == null) {
				return null;
			}

			if (List.class.isAssignableFrom(domainClass)) {
				return (DtoConverter<DTO, DOMAIN>) ((CollectionConverter)getDomainCollectionConverter(cache, this, (Class<List<WebSitesData>>)domainClass));
			}

			if (WebSitesData.class.isAssignableFrom(domainClass)) {
				return (DtoConverter<DTO, DOMAIN>) ((CollectionConverter)getDomainCollectionConverter(cache, this, (Class<List<WebSitesData>>)domainClass));
			}

			return null;
		}

		public <DTO, DOMAIN> DtoConverter<DTO, DOMAIN> getConverterForDto(Class<DTO> dto, ConvertedInstanceCache cache) {

			if (dto == null) {
				return null;
			}

			if (Collection.class.isAssignableFrom(dto)) {
				return (DtoConverter<DTO, DOMAIN>) ((CollectionConverter)getDtoCollectionConverter(cache, this, (Class<List<WebSitesDTO>>)dto));
			}

			if (WebSitesDTO.class.isAssignableFrom(dto)) {
				return (DtoConverter<DTO, DOMAIN>) getDtoWebSitesDTOConverter(transactionPropagations, cache, this, (Class<WebSitesDTO>)dto);
			}

			return null;
		}

	}
	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> InstantiableDtoConverter<DTO, DOMAIN> ensureDomainWebSitesDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, WebSitesData obj) {
		if (obj == null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDomainWebSitesDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends WebSitesData>)null);
		}

		return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDomainWebSitesDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends WebSitesData>)obj.getClass());
	}
	
	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> InstantiableDtoConverter<DTO, DOMAIN> ensureDomainWebSitesDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends WebSitesData> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDomain(objClass, cache);
		if (converter != null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) converter;
		}
		return getDomainWebSitesDTOConverter(transactionPropagations, cache, converterProvider, objClass);
	}

	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> InstantiableDtoConverter<DTO, DOMAIN> ensureDtoWebSitesDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, WebSitesDTO obj) {
		if (obj == null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDtoWebSitesDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends WebSitesDTO>)null);
		}

		return (InstantiableDtoConverter<DTO, DOMAIN>) ensureDtoWebSitesDTOConverter(transactionPropagations, cache, converterProvider, (Class<? extends WebSitesDTO>)obj.getClass());
	}
	
	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> InstantiableDtoConverter<DTO, DOMAIN> ensureDtoWebSitesDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends WebSitesDTO> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDto(objClass, cache);
		if (converter != null) {
			return (InstantiableDtoConverter<DTO, DOMAIN>) converter;
		}
		return getDtoWebSitesDTOConverter(transactionPropagations, cache, converterProvider, objClass);
	}

	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> InstantiableDtoConverter<DTO, DOMAIN> getDomainWebSitesDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends WebSitesData> objClass){
		return (InstantiableDtoConverter<DTO, DOMAIN>)new WebSitesDTOConverter(entityManager, transactionPropagations, cache, converterProvider);
	}

	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> InstantiableDtoConverter<DTO, DOMAIN> getDtoWebSitesDTOConverter(TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends WebSitesDTO> objClass){
		return (InstantiableDtoConverter<DTO, DOMAIN>)new WebSitesDTOConverter(entityManager, transactionPropagations, cache, converterProvider);
	}

	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> CollectionConverter<DTO, DOMAIN> ensureDomainCollectionConverter(ConvertedInstanceCache cache, ConverterProvider converterProvider, Collection<?> obj) {
		if (obj == null) {
			return (CollectionConverter<DTO, DOMAIN>) ensureDomainCollectionConverter(cache, converterProvider, (Class<? extends Collection<?>>)null);
		}

		return (CollectionConverter<DTO, DOMAIN>) ensureDomainCollectionConverter(cache, converterProvider, (Class<? extends Collection<?>>)obj.getClass());
	}
	
	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> CollectionConverter<DTO, DOMAIN> ensureDomainCollectionConverter(ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends Collection<?>> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDomain(objClass, cache);
		if (converter != null) {
			return (CollectionConverter<DTO, DOMAIN>) converter;
		}
		return getDomainCollectionConverter(cache, converterProvider, objClass);
	}

	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> CollectionConverter<DTO, DOMAIN> ensureDtoCollectionConverter(ConvertedInstanceCache cache, ConverterProvider converterProvider, Collection<?> obj) {
		if (obj == null) {
			return (CollectionConverter<DTO, DOMAIN>) ensureDtoCollectionConverter(cache, converterProvider, (Class<? extends Collection<?>>)null);
		}

		return (CollectionConverter<DTO, DOMAIN>) ensureDtoCollectionConverter(cache, converterProvider, (Class<? extends Collection<?>>)obj.getClass());
	}
	
	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> CollectionConverter<DTO, DOMAIN> ensureDtoCollectionConverter(ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends Collection<?>> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDto(objClass, cache);
		if (converter != null) {
			return (CollectionConverter<DTO, DOMAIN>) converter;
		}
		return getDtoCollectionConverter(cache, converterProvider, objClass);
	}

	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> CollectionConverter<DTO, DOMAIN> getDomainCollectionConverter(ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends Collection<?>> objClass){
		return new CollectionConverter<DTO, DOMAIN>(cache, converterProvider);
	}

	protected <DTO extends WebSitesDTO, DOMAIN extends WebSitesData> CollectionConverter<DTO, DOMAIN> getDtoCollectionConverter(ConvertedInstanceCache cache, ConverterProvider converterProvider, Class<? extends Collection<?>> objClass){
		return new CollectionConverter<DTO, DOMAIN>(cache, converterProvider);
	}

}